mod Ex06b logic: 'cl'

incl Mtex

incl Mtexg

incl Maux

loc rem 
  \para \bf  6. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end utorok 31.3.2015 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1415ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované párovacej 
  funkcii. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbory \it  mlogic*.cl  \end obsahujú popis verifikačnej 
         časti systému CL. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Downloadable lecture notes available through the web page of 
         the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/1 Tex1_appl_mu_sb
  Prefix(80,0,Id(0,Ent('mu'),0),Fenced(Op('[',0),Arg(0),Op(']',0)))

rem 
  \para \bf  Chapter. Beginning of Arithmetization.  \end 

rem 
  \para \bf  Section. Pairing Functions.  \end 

rem 
  \para \bf  Subsection. Catalan Pairing Function.  \end See also in [2] the 
  section \it  Suitable Pairing Function  \end in the chapter \it  Recursive 
  Bootstrapping of PA  \end. 

rem 
  \para \bf  [CL] Pairing function.  \end 
  \header* fun Term 'Tex1_g_appl_tau_sb' \end The following properties of the 
  Catalan pairing function are built in into the CL theorem prover: 
  \eq* 
    x1,x2 = y1,y2 <-> x1 = y1 & x2 = y2
  \end
  \eq* 
    x,y = 0 <-> \f
  \end
  \para Moreover, we have 
  \eq (occur_check)
    x = Term(x) <-> \f
  \end
  \para for terms \ft Term(x) \end of the form 
  \eq* 
    Tex2_g_equiv(Term(x),x,y)
  \end
  \eq* 
    Tex2_g_equiv(Term(x),y,x)
  \end
  \eq* 
    Tex2_g_equiv(Term(x),(x,y1),y2)
  \end
  \eq* 
    Tex2_g_equiv(Term(x),(y1,x),y2)
  \end
  \eq* 
    Tex2_g_equiv(Term(x),y1,x,y2)
  \end
  \eq* 
    Tex2_g_equiv(Term(x),y1,y2,x)
  \end
  \eq* 
    Tex0_dotsc
  \end

rem 
  \para \bf  [CL] Pair case analysis.  \end Syntax: 
  \eq* 
    'case P ; <term>'
  \end
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_case Tex_f2_g_x_sc(P,t) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_assum Tex_f2_g_eq(t,0),
                                              Tex_f1_g_x_assum Tex_f2_g_eq(t,v,w)))
         \end
         \para where \ft v \end and \ft w \end are new variables \it  
         (eigen-variables)  \end. 
  \end
  \para The predicate \ft P \end is defined in the module \it  Standard  \end. 

rem 
  \para \bf  [CL] Pair induction.  \end \header* fun R 'Tex1_g_appl_phi_sb' \end 
  Syntax: 
  \eq* 
    'ind P ; <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(P,x) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal R(x),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal R(0),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(R(v),
                                                                                        R(w)),
                                                                           R(v,w))))
         \end
   \item \para \ft Tex_f1_g_x_ind Tex_f2_g_x_sc(Tex_f2_g_x_sc(P,x),a) \end 
         \eq* 
           Tex_f2_g_x_nrule(Tex_f1_g_x_goal R(x),
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal R(0),
                                              Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_and(Tex_f2_g_forall(a,
                                                                                                        R(v)),
                                                                                        Tex_f2_g_forall(a,
                                                                                                        R(w))),
                                                                           R(v,w))))
         \end
  \end
  \para The predicate \ft P \end is defined in the module \it  Standard  \end. 

rem 
  \para \bf  [CL] Pair size.  \end The pair size function \ft |x| \end is 
  defined in the module \it  Standard  \end. The following its properties are 
  built in into the CL theorem prover: 
  \eq* 
    |0| = 0
  \end
  \eq* 
    |v,w| = |v|+|w|+1
  \end
  \eq* 
    |x| = 0 <-> x = 0
  \end
  \eq* 
    |x| = 1 <-> x = 0,0
  \end
  \eq* 
    |x++y| = |x|+|y|
  \end

rem 
  \para \bf  Subsubsection. Projections.  \end 

rem 
  \para \bf  Projection functions.  \end 

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(0) = 0
  Proj1(v,w) = v

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(0) = 0
  Proj2(v,w) = w

rem 
  \para \bf  Iteration of the second projection.  \end 

fun/2 Iproj2 'Tex_f2_pp_iproj2'
  Iproj2(0,x) = x
  Iproj2(n+1,x) = Proj2 Iproj2(n,x)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Iproj2(n,0) = 0
  \end
  \eq* 
    Proj2 Iproj2(n,x) = Iproj2(n,Proj2(x))
  \end
  \eq* 
    Iproj2(m+n,x) = Iproj2(m,Iproj2(n,x))
  \end

thm Iproj2_zero
  Iproj2(n,0) = 0

thm Iproj2_comm
  Proj2 Iproj2(n,x) = Iproj2(n,Proj2(x))

thm Iproj2_add
  Iproj2(m+n,x) = Iproj2(m,Iproj2(n,x))

rem 
  \para \bf  Subsubsection. Tupling.  \end 

rem 
  \para \bf  Exercise.  \end Find a primitive recursive definition of the 
  following function 
  \eq* 
    Twofib(n) = Fib(n),Fib(n+1)
  \end
  \para which does not contain any application of \ft Fib(n) \end. Prove that 
  the function satisfies the above property. Do not use auxiliary functions! 

fun Twofib 
  Twofib(n) = Foo

thm Fib_by_twofib
  Twofib(n) = Fib(n),Fib(n+1)

rem 
  \para \bf  Subsubsection. Pair Representation of Numbers.  \end 

rem 
  \para \bf  Reflection function.  \end 

fun Reflect 
  Reflect(0) = 0
  Reflect(v,w) = Reflect(w),Reflect(v)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Reflect(x) = 0 <-> x = 0
  \end
  \eq* 
    |Reflect(x)| = |x|
  \end
  \eq* 
    Reflect Reflect(x) = x
  \end
  \eq* 
    Reflect(x) = Reflect(y) -> x = y
  \end
  \eq* 
    \e y Reflect(y) = x
  \end

thm Reflect_is_zero
  Reflect(x) = 0 <-> x = 0

thm Reflect_szp
  |Reflect(x)| = |x|

thm Reflect_reflect
  Reflect Reflect(x) = x

thm Reflect_injective
  Reflect(x) = Reflect(y) -> x = y

thm Reflect_surjective
  \e y Reflect(y) = x

rem 
  \para \bf  Flattened trees.  \end 

pred Flattened 
  Flattened(0)
  Flattened(x,0) <- Flattened(x)

rem 
  \para \bf  Exercise.  \end Define the function \ft Flatten(x) \end such that 
  \eq* 
    |Flatten(x)| = |x|
  \end
  \eq* 
    Flattened Flatten(x)
  \end
  \para Do not use auxiliary functions! 

fun Flatten 
  Flatten(0) = 0
  Flatten(u,0) = Flatten(u),0
  Flatten(u,v,w) = Flatten((u,v),w)

thm Flatten_szp
  |Flatten(x)| = |x|

thm Flatten_flattened
  Flattened Flatten(x)

